/*************************************************************************************
*	irrlamb - http://irrlamb.googlecode.com
*	Copyright (C) 2010  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef GRAPPLE_H
#define GRAPPLE_H

// Libraries
#include "object.h"

// Forward Declarations
class PlayerClass;
	
// Classes
class GrappleClass : public ObjectClass {

	public:

		GrappleClass(const SpawnStruct &Object);
		~GrappleClass();

		void HandleCollision(ObjectClass *TOtherObject, const btPersistentManifold *TContactManifold, float TNormalScale);
		void SetGrappleParent(PlayerClass *TObject);

	private:

		PlayerClass *GrappleParentObject;
};

#endif
